/* calcbtn.h */

/*
 * constants
 */

#define noErr 0

#define CREATOR 'CBTN'

#define APP_DB_TYPE 'appl'
#define DA_DB_TYPE 'DAcc'

#define OLD_PREF_VERSION 1
#define PREF_VERSION 2

enum mode {
    MODE_NONE,
    MODE_CALC,
    MODE_CALC_APP,
    MODE_CALC_DA,
    MODE_GRAFFITI,
    MODE_KEYBOARD,
    MODE_KEYBOARD_ABC,
    MODE_KEYBOARD_123
};

#define DEFAULT_BUTTON1 MODE_NONE
#define DEFAULT_BUTTON2 MODE_CALC
#define DEFAULT_BUTTON3 MODE_CALC_APP
#define DEFAULT_BUTTON4 MODE_CALC_DA

#define DEFAULT_CALC_APP 'calc'		/* built-in calculator */
#define DEFAULT_CALC_DA 'MNCL'		/* kish's CalCal DA */

#define DEFAULT_STACK_SIZE 3000
#define STACK_UNIT 1000

#define DEFAULT_LOCALIZER true


/*
 * types
 */

struct old_calcbtn_prefs {
    Byte button1;
    Byte button2;
    Byte button3;
    Byte button4;

    ULong calc_app;
    ULong calc_da;
    Word stack_size;
};

struct calcbtn_prefs {
    Byte button1;
    Byte button2;
    Byte button3;
    Byte button4;

    ULong calc_app;
    ULong calc_da;
    Word stack_size;
    Byte localizer;
    Byte reserved;
};


/*
 * functions (!)
 */

static void get_prefs(struct calcbtn_prefs *prefs)
{
    if (PrefGetAppPreferencesV10(
	    CREATOR, PREF_VERSION, prefs, sizeof *prefs) == false) {
	if (PrefGetAppPreferencesV10(CREATOR, OLD_PREF_VERSION,
		prefs, sizeof(struct old_calcbtn_prefs)) == false) {
	    *(DWord *) &prefs->button1 =
		    (DWord) DEFAULT_BUTTON1 << 24 |
		    (DWord) DEFAULT_BUTTON2 << 16 |
		    (DWord) DEFAULT_BUTTON3 << 8 |
		    (DWord) DEFAULT_BUTTON4;

	    prefs->calc_app = DEFAULT_CALC_APP;
	    prefs->calc_da = DEFAULT_CALC_DA;
	    prefs->stack_size = DEFAULT_STACK_SIZE;
	}

	*(Word *) &prefs->localizer = (Word) DEFAULT_LOCALIZER << 8;
    }
}
