/* findbtn.h */

/*
 * constants
 */

#define noErr 0

#define CREATOR 'FBTN'

#define APP_DB_TYPE 'appl'
#define DA_DB_TYPE 'DAcc'

#define PREF_VERSION 1

enum mode {
    MODE_NONE,
    MODE_APP1,
    MODE_APP2,
    MODE_DA1,
    MODE_DA2,
    MODE_GRAFFITI,
    MODE_KEYBOARD,
    MODE_KEYBOARD_ABC,
    MODE_KEYBOARD_123
};

#define DEFAULT_BUTTON1 MODE_NONE
#define DEFAULT_BUTTON2 MODE_GRAFFITI
#define DEFAULT_BUTTON3 MODE_APP1
#define DEFAULT_BUTTON4 MODE_DA1

#define DEFAULT_STACK_SIZE 3000
#define STACK_UNIT 1000

#define DEFAULT_LOCALIZER true


/*
 * types
 */

struct findbtn_prefs {
    Byte button1;
    Byte button2;
    Byte button3;
    Byte button4;

    ULong app1;
    ULong app2;
    ULong da1;
    ULong da2;

    Word stack_size;
    Byte localizer;
    Byte reserved;
};


/*
 * functions (!)
 */

static void get_prefs(struct findbtn_prefs *prefs)
{
    if (PrefGetAppPreferencesV10(
	    CREATOR, PREF_VERSION, prefs, sizeof *prefs) == false) {
	*(DWord *) &prefs->button1 =
		(DWord) DEFAULT_BUTTON1 << 24 |
		(DWord) DEFAULT_BUTTON2 << 16 |
		(DWord) DEFAULT_BUTTON3 << 8 |
		(DWord) DEFAULT_BUTTON4;

	prefs->app1 = 0;
	prefs->app2 = 0;
	prefs->da1 = 0;
	prefs->da2 = 0;

	*(DWord *) &prefs->stack_size =
		(DWord) DEFAULT_STACK_SIZE << 16 |
		(DWord) DEFAULT_LOCALIZER << 8;
    }
}
